## mikmod 2.14

=== source/Makefile ===
############################################################################
#									   #
# Instructions:								   #
# -------------								   #
# 1. Select the appropriate OS-specific options for your system		   #
# 2. Choose from the options section					   #
# 3. Type "make" and all should (hopefully) work...			   #
#									   #
############################################################################

############################################################################
############################################################################
##									  ##
##			OS-SPECIFIC DEFINITIONS				  ##
##									  ##
############################################################################
############################################################################

############################################################################
#
# Linux/FreeBSD/OSS definitions
#
# for output on linux and FreeBSD Open Sound System (OSS) (/dev/dsp) or 
# Ultrasound driver (/dev/gus)
#
############################################################################

OSDEF=-DOSS
CC = gcc

# if you want to use the Ultra driver uncomment the 3 lines below. 
# You need a Gravis Ultrasound and the library from the Linux Ultrasound 
# project to do this, from http://romeo.pf.jcu.cz/~perex/ultra/
#ULTRA=-DULTRA
#ULTRALIB=-lgus
#ULTRADRV=drv_ultra.o

OSFLAGS = -O2 $(OSDEF) $(ULTRA)
#debug options
#OSFLAGS = -g $(OSDEF) $(ULTRA)

LIBS=-lncurses -lm $(ULTRALIB)
DRIVERS = drv_nos.o drv_raw.o drv_vox.o $(ULTRADRV)

############################################################################
#
# SUN / Solaris definitions (including Solaris/i386)
#
# for output on the Sun audio device (/dev/audio)
#
############################################################################

# for SunOS 4.1.x, enable -DSUNOS, for Solaris 2.x, enable -DSOLARIS
#OSDEF=-DSUNOS -I/usr/5include
#OSDEF=-DSOLARIS

#CC = gcc

# defines
# For Solaris/i386, remove the -DMM_BIG_ENDIAN
#CDEFS=-DNEED_UNISTD -DMM_BIG_ENDIAN -DSUN $(OSDEF)

# Enable this for speed on v8 sparc (microSPARC and newer)
#OSFLAGS = -g -O2 -mv8 -msupersparc -I./include $(CDEFS)
# Enable this to work on v7 sparc
#OSFLAGS = -g -O2 -I./include $(CDEFS)
# SPARCompiler C 4.0 options
#OSFLAGS = -Iinclude -fast -s $(CDEFS)

# Use SysV curses. Gets us the lame SysV libc too. Oh well
#LIBS=-L/usr/5lib -lcurses -lm
# Disable the above and use this on Solaris
#LIBS=-lcurses -lm -lposix4

#DRIVERS = drv_nos.o drv_raw.o drv_sun.o

############################################################################
#
# DEC Alpha / AudioFile definitions
#
# systems using Digital AudioFile library, available from 
# ftp://crl.dec.com/pub/DEC/AF
#
############################################################################

#OSDEF=-DALPHA

# Choose between DEC cc
#CC = cc -g3

# and GNU gcc
#CC = gcc -g


# On my system I have to do
#INCDIR=-I/usr/local/vol/AudioFile/include
#LIBDIR=-L/usr/local/vol/AudioFile/lib

#OSFLAGS = -O2 $(OSDEF) $(INCDIR)
#DRIVERS = drv_nos.o drv_raw.o drv_AF.o
#LIBS=$(LIBDIR) -lcurses -lm -lAF

############################################################################
#
#   AIX definitions
#
############################################################################
 
#OSDEF=-DAIX
#CC = gcc

#OSFLAGS = -O3 -fsigned-char $(OSDEF) -DMM_BIG_ENDIAN

#LIBS=-lcurses -lm
#DRIVERS = drv_nos.o drv_aix.o drv_raw.o

############################################################################
#
#   HP 9000 series / HP-UX definitions
#
############################################################################

#OSDEF=-DHPUX

# To use gcc instead of HP's cc, uncomment the following two lines.
# HP's cc (NOT THE BUNDLED ONE) produces about 6% faster code here 
#CC = gcc
#OSFLAGS = -O3 -funroll-loops -mpa-risc-1-1 -mschedule=7100 $(OSDEF) -DMM_BIG_ENDIAN

# OR use HP's CC:

#CC = cc
#OSFLAGS = -Ae +O3 $(OSDEF) -DMM_BIG_ENDIAN

# Both need these:
#LIBS = -lcurses -L/lib/pa1.1 -lm
#DRIVERS = drv_nos.o drv_raw.o drv_hp.o

############################################################################
#
#   SGI definitions
#
############################################################################

#OSDEF=-DSGI
#CC = gcc

#CFLAGS = -O2 $(OSDEF) $(ZIP) $(USLEEP) $(NCURSES) -DMM_BIG_ENDIAN
#
#LIBS=-lcurses -laudio -lm 
#DRIVERS = drv_nos.o drv_raw.o drv_sgi.o

############################################################################
############################################################################
##									  ##
##			OPTIONS DEFINITIONS				  ##
##									  ##
############################################################################
############################################################################

# if you have unzip etc. installed, enable this for transparent loading of
# zipped mods. If you define this, you may need programs to extract zip,
# lha, gz, arj and zoo archives. Define the locations for these in mikmod.h
ZIP=-DUSE_ZIP

# -s will renice the program to -19, -S will attempt to give it a
# realtime priority (ie. it'll get all the cpu it wants) using
# sched_setscheduler(). Default behaviour remains the same, i.e. to not use
# these
SNAG=-DCPUTIME_SNAGGER

# Does your system have usleep()? If not, you'll need to uncomment this...
#USLEEP=-DNEEDS_USLEEP

# Does your system have curses or ncurses? If the latter, define NCURSES.
#NCURSES=-DNCURSES

CFLAGS = $(OSFLAGS) $(ZIP) $(SNAG) $(USLEEP) $(NCURSES)

############################################################################
############################################################################
##									  ##
##  Common / standard definitions - shouldn't need to touch below here!   ##
##									  ##
############################################################################
############################################################################

LOADERS = load_mod.o load_m15.o load_mtm.o load_s3m.o load_stm.o load_xm.o load_ult.o load_uni.o load_669.o
OBJ = mikcvt.o mloader.o munitrk.o mmio.o
OBJ2 = mikmodux.o virtch.o mloader.o mdriver.o mplayer.o munitrk.o mmio.o ui.o display.o
ARC = marchive.o

all:	mikmod mikcvt

debug:	mikmod-debug

mikmod: $(OBJ2) $(LOADERS) $(DRIVERS) $(ARC)
	$(CC) -Dunix $(CFLAGS) $(ARC) $(OBJ2) $(LOADERS) $(DRIVERS) -o $@ $(LIBS)
	strip $@

mikmod-debug: $(OBJ2) $(LOADERS) $(DRIVERS) $(ARC)
	$(CC) -Dunix $(CFLAGS) $(ARC) $(OBJ2) $(LOADERS) $(DRIVERS) -o $@ $(LIBS)

mikmod-e: $(OBJ2) $(LOADERS) $(DRIVERS) $(ARC)
	$(CC) -Dunix $(CFLAGS) $(ARC) $(OBJ2) $(LOADERS) $(DRIVERS) -o mikmod-debug -lefence $(LIBS)

mikcvt: $(OBJ) $(LOADERS) $(ARC)
	$(CC) -Dunix $(CFLAGS) $(ARC) $(OBJ) $(LOADERS) -o $@ $(LIBS)
	strip $@

clean:
	rm -f $(OBJ) $(OBJ2) $(DRIVERS) $(ARC) $(LOADERS) mikmod mikcvt mikmod-debug *~

tgz:	clean
	(cd ../../ ;tar -cvf - mikmod-2.14-unix/* |gzip -9 >mikmod-2.14-unix.tar.gz)
	cp ../docs/Changes ../docs/ToDo ../..

## mikmod 3.0.4

=== Makefile ===
#! /usr/bin/make -f

all:	FORCE
	(cd extra      ; $(MAKE) all)
	(cd mmio       ; $(MAKE) all)
	(cd playercode ; $(MAKE) all)
	(cd usercode   ; $(MAKE) all)

clean:	FORCE
	(cd extra      ; $(MAKE) clean)
	(cd mmio       ; $(MAKE) clean)
	(cd playercode ; $(MAKE) clean)
	(cd usercode   ; $(MAKE) clean)

distclean:	clean
	rm -f mikmod core {extra,mmio,playercode,usercode}/Makefile

FORCE:

## mikmod 3.2.1

=== debian/changelog ===
mikmod (3.2.1-4) unstable; urgency=low

  * Bump debhelper compat level to 9.
  * Update Standards-Version to 3.9.3 (no changes required)
  * Recommend oss-compat.

 -- Gergely Nagy <algernon@madhouse-project.org>  Fri, 06 Apr 2012 00:07:30 +0200

mikmod (3.2.1-3) unstable; urgency=low

  * New maintainer. (Closes: #628163).
  * Convert to dh(7) short-form.
    + As a result, don't strip binaries when nostrip is specified in
      DEB_BUILD_OPTIONS. (Closes: #437566)
  * Update Standards-Version to 3.9.2.
  * Add Homepage and VCS-* fields.
  * Convert to Format: 3.0 (quilt).
  * Use autotools-dev to refresh config.sub/config.guess.

 -- Gergely Nagy <algernon@madhouse-project.org>  Sat, 29 Oct 2011 21:19:22 +0200

mikmod (3.2.1-2) unstable; urgency=low

  * Fix playmode documentation in the manpage. The default: output of
    mikmod -h does depend on your actual mikmod configuration, and is correct
    for an unconfigured mikmod. (Closes: #305445)
  * Fix manpage to use HYPHEN-MINUS ("\-") instead of HYPHEN ("-"), which
    would be rendered differently on unicode terminals.

 -- Ingo Saitz <ingo@debian.org>  Thu, 28 Apr 2005 18:52:14 +0200

mikmod (3.2.1-1) unstable; urgency=low

  * New upstream version from Raphael Assenat (Closes: #214431)
    + New upstream maintainer
    + Includes all patches from the previous debian version
    + Now uses color on capable terminals
  * Eliminate some compile warnings.
  * Document --color in the manpage.
  * Preventively fix Bug #104980 again.
  * Package complies to debian policy 3.6.1: no changes.

 -- Ingo Saitz <ingo@debian.org>  Wed, 31 Dec 2003 03:57:34 +0100

mikmod (3.1.6-7) unstable; urgency=low

  * Fixed va_arg handling in mconfedit.c (FTBFS on hppa) (Closes: #196012)

 -- Ingo Saitz <ingo@debian.org>  Wed,  4 Jun 2003 12:19:43 +0200

mikmod (3.1.6-6) unstable; urgency=medium

  * Fix possible (?) buffer overflow and malicious filename in marchiver.c
  * Can use filenames with spaces in archives now, and
  * Added additional prefixes found on aminet (Closes: #193634)
  * Added archivers as Suggests (all but gzip and tar, those are Essential).
  * Package complies to debian policy 3.5.10

 -- Ingo Saitz <ingo@debian.org>  Mon,  2 Jun 2003 11:26:11 +0200

mikmod (3.1.6-5) unstable; urgency=low

  * Debian Policy 3.5.8: Adapt to new DEB_BUILD_OPTIONS.
  * Most probably the old bug fixed in libmikmod2 3.1.9-4. Since I never heard
    from the reporter, I close it (Closes: #81000)
  * Split patches from the source into debian/patches/.
  * Remove use of dh_testversion.
  * Point to /usr/share/common-licenses/GPL-2 in copyright.

 -- Ingo Saitz <ingo@debian.org>  Thu, 23 Jan 2003 14:07:28 +0100

mikmod (3.1.6-4) unstable; urgency=low

  * fix compiling with gcc 3.0 (printf is a macro, Closes: #104980).
  * fix broken autoconf on new architectures (no bug yet :)
  * more documentation fixes (mikmod --help) and cleanup.
  * Package complies with Policy 3.5.5: no changes.

 -- Ingo Saitz <ingo@debian.org>  Fri, 20 Jul 2001 22:29:24 +0200

mikmod (3.1.6-3) unstable; urgency=low

  * New Maintainer
  * Recompiled package (Closes: #64698, #91589)
  * Policy 3.5.2:
    - added Build-Depends: (Closes: #85249, #88570)
    - parse DEB_BUILD_OPTIONS for "debug"
  * Fixed getopt processing and documentation (manpage, Closes: #88867)

 -- Ingo Saitz <ingo@debian.org>  Sat, 31 Mar 2001 00:16:50 +0200

mikmod (3.1.6-2) unstable; urgency=low

  * Applied upstream -a level patch

 -- Joseph Carter <knghtbrd@debian.org>  Thu,  5 Aug 1999 06:38:17 -0700

mikmod (3.1.6-1) unstable; urgency=low

  * New upstream version
  * Policy 3.0.0, debhelper v2 (hi joeyh!)  
  * Removed Suggests line for non-free archivers since if you have tracks
    that are compressed with an archiver you know you need the archiver.

 -- Joseph Carter <knghtbrd@debian.org>  Thu,  8 Jul 1999 06:22:27 -0700

mikmod (3.1.5-1) unstable; urgency=low

  * New upstream version (Closes: #34493, #39421)
  * libmikmod is now a seperate package which will only use ALSA or EsounD
    if they are available (Closes: #38242, #29133)

 -- Joseph Carter <knghtbrd@debian.org>  Sun, 13 Jun 1999 15:14:32 -0700

mikmod (3.1.2-2) unstable; urgency=low

  * Rebuilt for potato's ALSA

 -- Joseph Carter <knghtbrd@debian.org>  Thu, 28 Jan 1999 12:21:21 -0800

mikmod (3.1.2-1) unstable; urgency=low

  * New upstream version

 -- Joseph Carter <knghtbrd@debian.org>  Fri, 18 Dec 1998 23:58:33 -0800

mikmod (3.0.4-2) unstable; urgency=low

  * Applied 3 upstream patches to fix bugs and add ALSA support
  * Built also with ALSA support

 -- Joseph Carter <knghtbrd@debian.org>  Tue, 13 Oct 1998 09:38:22 -0700

mikmod (3.0.4-1) unstable; urgency=low

  * New maintainer.
  * New upstream version.
  * This package is now DFSG free (GPL and LGPL).
  * Massive upstream revisions including both non-compressed and compressed
    sample Impulse Tracker support.
  * Built with both OSS and EsounD driver support.

 -- Joseph Carter <knghtbrd@debian.org>  Fri,  9 Oct 1998 09:14:53 -0700

mikmod (2.14-3) unstable; urgency=low

  * Libc 6 release - replaces non-maintainer release (fixes bug #14933)
  * Back to my non-debstd rules file, so changelog.Debian compressed again (fixes bug #15436)
  * Removed surplus documentation (fixes bug #18111)
  * Next release (v3.0) due soon, should be DFSG.

 -- Steve McIntyre <stevem@chiark.greenend.org.uk>  Thu, 12 Mar 1998 23:31:32 +0000

mikmod (2.14-2) unstable; urgency=low

  * Oops! Changed banner message from development version...

 -- Steve McIntyre <stevem@chiark.greenend.org.uk>  Wed, 1 Jan 1997 16:40:39 +0000

mikmod (2.14-1) unstable; urgency=low

  * New upstream version.
  * Fixes Bug#6276 - mikcvt now has a man page.
  * Fixes Bug#5671 - errors now re-displayed on exit.

 -- Steve McIntyre <stevem@chiark.greenend.org.uk>  Wed, 1 Jan 1997 14:10:39 +0000

=== debian/control ===
Source: mikmod
Section: sound
Priority: optional
Maintainer: Gergely Nagy <algernon@madhouse-project.org>
Build-Depends: debhelper (>= 9~), autotools-dev, libmikmod2-dev, libncurses5-dev
Standards-Version: 3.9.3
Homepage: http://mikmod.raphnet.net
Vcs-Git: git://git.madhouse-project.org/debian/mikmod.git
Vcs-Browser: http://git.madhouse-project.org/debian/mikmod/

Package: mikmod
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: oss-compat
Suggests: bzip2, lha, unrar, unzip, zoo
Description: Portable tracked music player
 Mikmod is a very portable tracked music player which supports a wide
 variety of module formats including compressed sample Impulse Tracker
 modules. It also supports many archive formats, as well as on the fly
 decompression.

## mikmod 3.2.5

=== CMakeLists.txt ===
# if necessary, set CMAKE_PREFIX_PATH to the path where libmikmod
# is installed, which you can do on your cmake command line, like:
# cmake -DCMAKE_PREFIX_PATH=/path/to/libmikmod_dir ....

PROJECT(mikmod C)
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)
LIST(APPEND CMAKE_MODULE_PATH "${mikmod_SOURCE_DIR}/cmake")

SET (VERSION "3.2.5")

STRING (REGEX MATCHALL "([0-9]+)" VERSION_DIGITS "${VERSION}")

LIST(GET VERSION_DIGITS 0 CPACK_PACKAGE_VERSION_MAJOR)
LIST(GET VERSION_DIGITS 1 CPACK_PACKAGE_VERSION_MINOR)
LIST(GET VERSION_DIGITS 2 CPACK_PACKAGE_VERSION_PATCH)

# package generation (make package[_source])
SET(CPACK_PACKAGE_NAME "mikmod")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "MikMod - a module player")
SET(CPACK_PACKAGE_VENDOR "Shlomi Fish")
SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")

SET(CPACK_PACKAGE_INSTALL_DIRECTORY "${CPACK_PACKAGE_DESCRIPTION_SUMMARY} ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")

SET (base_with_ver "mikmod-[0-9]+\\\\.[0-9]+\\\\.[0-9]+")
SET(CPACK_SOURCE_IGNORE_FILES
    "/_CPack_Packages/"
    "/CMakeFiles/"
    "/.deps/"
    "^${base_with_ver}(-Source|-Linux)?/"
    "${base_with_ver}.tar\\\\.(gz|bz2|Z|lzma|xz)$"
    "\\\\.o$"
    "~$"
    "/\\\\.svn/"
    "/CMakeCache\\\\.txt$"
    "/CTestTestfile\\\\.cmake$"
    "/cmake_install\\\\.cmake$"
    "/CPackConfig\\\\.cmake$"
    "/CPackSourceConfig\\\\.cmake$"
    "/tags$"
    "^config\\\\.h$"
    "/install_manifest\\\\.txt$"
    "/Testing/"
    "ids-whitelist\\\\.txt"
    "/_Inline/"
    "/(B|build|BUILD)/"
    "/autom4te.cache/"
)

INCLUDE(CPack)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckSymbolExists)
INCLUDE(CheckCCompilerFlag)
INCLUDE(CheckCSourceCompiles)
include(mik_macros)

find_path(MIKMOD_INCLUDE_DIR mikmod.h)
find_library(MIKMOD_LIBRARIES mikmod)
IF (MIKMOD_LIBRARIES STREQUAL "MIKMOD_LIBRARIES-NOTFOUND")
    MESSAGE(FATAL_ERROR "libmikmod not found.")
ELSE()
    MESSAGE(STATUS "Found MikMod: ${MIKMOD_LIBRARIES}")
ENDIF()

IF(UNIX OR APPLE)
  INCLUDE(FindCurses)
  IF(NOT CURSES_FOUND)
    MESSAGE(FATAL_ERROR "Curses not found.")
  ENDIF()
ENDIF()

CHECK_MULTI_INCLUDE_FILES(
    "ncurses.h"
    "fcntl.h" "fnmatch.h" "inttypes.h" "limits.h" "memory.h" "sched.h"
    "sys/ioctl.h" "sys/wait.h" "sys/time.h" "sys/types.h" "sys/stat.h"
    "stdint.h" "stdlib.h" "string.h" "strings.h" "termios.h" "unistd.h"
    "pthread.h"
)

CHECK_SYMBOL_EXISTS(TIOCGWINSZ "sys/ioctl.h" GWINSZ_IN_SYS_IOCTL)
CHECK_SYMBOL_EXISTS(usleep unistd.h HAVE_USLEEP_PROTO)
IF (NOT HAVE_USLEEP_PROTO)
    CHECK_SYMBOL_EXISTS(usleep "sys/unistd.h" HAVE_USLEEP_PROTO)
ENDIF()

IF (HAVE_PTHREAD_H)
    SET (HAVE_PTHREAD 1)
ENDIF (HAVE_PTHREAD_H)

CHECK_MULTI_FUNCTIONS_EXISTS(
    "getopt_long_only"
    mkstemp srandom snprintf vsnprintf strerror
    usleep
    srandom
    fnmatch
    memcmp
    vprintf
)

IF (HAVE_USLEEP)
    SET (HAVE_USLEEP_PROTO 1)
ENDIF (HAVE_USLEEP)

CHECK_C_SOURCE_COMPILES(
 "#include <sys/types.h>
  #include <signal.h>
  int main(void) { return *(signal(0,0))(0) == 1; }"
  RETSIGTYPE_INT
)
if(RETSIGTYPE_INT)
  set(RETSIGTYPE int)
else(RETSIGTYPE_INT)
  set(RETSIGTYPE void)
endif(RETSIGTYPE_INT)
MESSAGE(STATUS "Return type of signal handlers: ${RETSIGTYPE}")

SET(CMAKE_REQUIRED_LIBRARIES "ncurses")
CHECK_FUNCTION_EXISTS (resizeterm HAVE_NCURSES_RESIZETERM)

SET(CMAKE_REQUIRED_INCLUDES ${MIKMOD_INCLUDE_DIR})
SET(CMAKE_REQUIRED_LIBRARIES ${MIKMOD_LIBRARIES})
CHECK_FUNCTION_EXISTS (MikMod_free HAVE_MIKMOD_FREE)

########### compiler flags ##############

SET(COMPILER_FLAGS_TO_CHECK
    "-Wall" "-Werror=implicit-function-declaration"
)

IF (CPU_ARCH)
    LIST(APPEND COMPILER_FLAGS_TO_CHECK "-march=${CPU_ARCH}")
ENDIF(CPU_ARCH)

SET (IDX 1)
FOREACH (CFLAG_TO_CHECK ${COMPILER_FLAGS_TO_CHECK})
    SET (FLAG_EXISTS_VAR "FLAG_EXISTS_${IDX}")
    MATH (EXPR IDX "${IDX} + 1")
    CHECK_C_COMPILER_FLAG("${CFLAG_TO_CHECK}" ${FLAG_EXISTS_VAR})
    IF (${FLAG_EXISTS_VAR})
        ADD_DEFINITIONS(${CFLAG_TO_CHECK})
    ENDIF (${FLAG_EXISTS_VAR})
ENDFOREACH(CFLAG_TO_CHECK)

########### install files ###############

ADD_DEFINITIONS("-DHAVE_CONFIG_H")
SET (PACKAGE_DATA_DIR "${CMAKE_INSTALL_PREFIX}/share/mikmod")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# So it can find the includes when building libavl.avl.h.
INCLUDE_DIRECTORIES(BEFORE ${CMAKE_CURRENT_SOURCE_DIR})

# So it can find config.h
INCLUDE_DIRECTORIES(BEFORE ${CMAKE_CURRENT_BINARY_DIR})

install(
    FILES
        mikmodrc
    DESTINATION
        "share/mikmod"
)

add_subdirectory(src)
add_subdirectory(dos)
add_subdirectory(os2)
add_subdirectory(win32)

=== src/CMakeLists.txt ===

########### next target ###############

SET(mikmod_SRCS
   display.c
   marchive.c
   mikmod.c
   mlist.c
   mconfig.c
   mwindow.c
   mmenu.c
   mwidget.c
   mdialog.c
   mconfedit.c
   mutilities.c
   mplayer.c
   mlistedit.c
   rcfile.c
)

IF (NOT HAVE_USLEEP)
    LIST (APPEND mikmod_SRCS "musleep.c")
ENDIF (NOT HAVE_USLEEP)
IF (NOT HAVE_FNMATCH)
    LIST (APPEND mikmod_SRCS "mfnmatch.c")
ENDIF (NOT HAVE_FNMATCH)
IF (NOT HAVE_GETOPT_LONG_ONLY)
    LIST (APPEND mikmod_SRCS "mgetopt.c")
    LIST (APPEND mikmod_SRCS "mgetopt1.c")
ENDIF (NOT HAVE_GETOPT_LONG_ONLY)

include_directories(${MIKMOD_INCLUDE_DIR})

add_executable(mikmod ${mikmod_SRCS})

target_link_libraries(mikmod "ncurses" "pthread" ${MIKMOD_LIBRARIES})

install(TARGETS mikmod DESTINATION bin)

=== debian/changelog ===
mikmod (3.2.5-1) unstable; urgency=medium

  * New upstream version, uploaded to unstable now that libmikmod3 is
    available there.

 -- Stephen Kitt <skitt@debian.org>  Tue, 25 Mar 2014 23:34:15 +0100

mikmod (3.2.4-1) experimental; urgency=low

  * New maintainer (closes: #728592).
  * New upstream version.
  * Build with libmikmod3, enabling support for modern audio backends
    (closes: #729058).
  * Update patches:
    - drop 0001-Eliminate-compile-warnings.patch, obsolete;
    - drop 0002-Document-the-color-option.patch, obsolete;
    - drop 0003-Correct-the-playmode-documentation.patch, fixed otherwise
      upstream;
    - update 0004-Fix-hyphens-in-the-manual-pages.patch.
  * Add watch file.
  * Standards-Version 3.9.5, no further change required.
  * Drop old VCS URIs.

 -- Stephen Kitt <skitt@debian.org>  Tue, 17 Dec 2013 00:10:55 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,10 @@
 Source: mikmod
 Section: sound
 Priority: optional
-Maintainer: Gergely Nagy <algernon@madhouse-project.org>
-Build-Depends: debhelper (>= 9~), autotools-dev, libmikmod2-dev, libncurses5-dev
-Standards-Version: 3.9.3
-Homepage: http://mikmod.raphnet.net
-Vcs-Git: git://git.madhouse-project.org/debian/mikmod.git
-Vcs-Browser: http://git.madhouse-project.org/debian/mikmod/
+Maintainer: Stephen Kitt <skitt@debian.org>
+Build-Depends: debhelper (>= 9~), autotools-dev, libmikmod-dev (>= 3.3.4), libncurses5-dev
+Standards-Version: 3.9.5
+Homepage: http://mikmod.sf.net
 
 Package: mikmod
 Architecture: any

## mikmod 3.2.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,9 +6,9 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 2.8)
 LIST(APPEND CMAKE_MODULE_PATH "${mikmod_SOURCE_DIR}/cmake")
 
-SET (VERSION "3.2.5")
-
-STRING (REGEX MATCHALL "([0-9]+)" VERSION_DIGITS "${VERSION}")
+SET(VERSION "3.2.6")
+
+STRING(REGEX MATCHALL "([0-9]+)" VERSION_DIGITS "${VERSION}")
 
 LIST(GET VERSION_DIGITS 0 CPACK_PACKAGE_VERSION_MAJOR)
 LIST(GET VERSION_DIGITS 1 CPACK_PACKAGE_VERSION_MINOR)
@@ -18,13 +18,13 @@
 SET(CPACK_PACKAGE_NAME "mikmod")
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "MikMod - a module player")
 SET(CPACK_PACKAGE_VENDOR "Shlomi Fish")
-SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
-SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
+SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README")
+SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
 
 SET(CPACK_PACKAGE_INSTALL_DIRECTORY "${CPACK_PACKAGE_DESCRIPTION_SUMMARY} ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
 SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
 
-SET (base_with_ver "mikmod-[0-9]+\\\\.[0-9]+\\\\.[0-9]+")
+SET(base_with_ver "mikmod-[0-9]+\\\\.[0-9]+\\\\.[0-9]+")
 SET(CPACK_SOURCE_IGNORE_FILES
     "/_CPack_Packages/"
     "/CMakeFiles/"
@@ -56,6 +56,21 @@
 INCLUDE(CheckCSourceCompiles)
 include(mik_macros)
 
+CHECK_MULTI_INCLUDE_FILES(
+    "ncurses.h" "curses.h" "ncurses/curses.h" "termios.h"
+    "fcntl.h" "fnmatch.h" "inttypes.h" "limits.h" "memory.h" "sched.h"
+    "sys/ioctl.h" "sys/param.h" "sys/wait.h" "sys/time.h" "sys/types.h"
+    "sys/stat.h" "stdint.h" "stdlib.h" "string.h" "strings.h" "unistd.h"
+    "pthread.h"
+)
+CHECK_SYMBOL_EXISTS(TIOCGWINSZ "sys/ioctl.h" GWINSZ_IN_SYS_IOCTL)
+CHECK_SYMBOL_EXISTS(usleep unistd.h HAVE_USLEEP_PROTO)
+IF (NOT HAVE_USLEEP_PROTO)
+    CHECK_SYMBOL_EXISTS(usleep "sys/unistd.h" HAVE_USLEEP_PROTO)
+ENDIF()
+
+SET(EXTRA_LIBS )
+
 find_path(MIKMOD_INCLUDE_DIR mikmod.h)
 find_library(MIKMOD_LIBRARIES mikmod)
 IF (MIKMOD_LIBRARIES STREQUAL "MIKMOD_LIBRARIES-NOTFOUND")
@@ -69,25 +84,66 @@
   IF(NOT CURSES_FOUND)
     MESSAGE(FATAL_ERROR "Curses not found.")
   ENDIF()
-ENDIF()
-
-CHECK_MULTI_INCLUDE_FILES(
-    "ncurses.h"
-    "fcntl.h" "fnmatch.h" "inttypes.h" "limits.h" "memory.h" "sched.h"
-    "sys/ioctl.h" "sys/wait.h" "sys/time.h" "sys/types.h" "sys/stat.h"
-    "stdint.h" "stdlib.h" "string.h" "strings.h" "termios.h" "unistd.h"
-    "pthread.h"
-)
-
-CHECK_SYMBOL_EXISTS(TIOCGWINSZ "sys/ioctl.h" GWINSZ_IN_SYS_IOCTL)
-CHECK_SYMBOL_EXISTS(usleep unistd.h HAVE_USLEEP_PROTO)
-IF (NOT HAVE_USLEEP_PROTO)
-    CHECK_SYMBOL_EXISTS(usleep "sys/unistd.h" HAVE_USLEEP_PROTO)
-ENDIF()
-
-IF (HAVE_PTHREAD_H)
+
+  IF(HAVE_NCURSES_H)
+     SET(CURSES_HDR "ncurses.h")
+  ELSEIF(HAVE_CURSES_H)
+     SET(CURSES_HDR "curses.h")
+  ELSEIF(HAVE_NCURSES_CURSES_H)
+     SET(CURSES_HDR "ncurses/curses.h")
+  ELSE()
+      MESSAGE(FATAL_ERROR "Neither ncurses.h nor curses.h found.")
+  ENDIF()
+
+  SET(CMAKE_REQUIRED_LIBRARIES ${CURSES_LIBRARY})
+  CHECK_FUNCTION_EXISTS (resizeterm HAVE_NCURSES_RESIZETERM)
+  CHECK_C_SOURCE_COMPILES(
+   "#include <${CURSES_HDR}>
+     int main(void) {
+#ifdef ACS_ULCORNER
+     return ACS_ULCORNER;
+#endif
+     return 0; }"
+     CURSES_LINKSOK
+  )
+  IF(CURSES_LINKSOK)
+    LIST (APPEND EXTRA_LIBS ${CURSES_LIBRARY})
+  ELSE()
+    find_library(TINFO_LIBRARY tinfo)
+    IF(TINFO_LIBRARY STREQUAL "TINFO_LIBRARY-NOTFOUND")
+      MESSAGE(FATAL_ERROR "libtinfo needed for ncurses, but not found.")
+    ELSE()
+      MESSAGE(STATUS "Found libtinfo: ${TINFO_LIBRARY}")
+      SET(CMAKE_REQUIRED_LIBRARIES ${CURSES_LIBRARY} ${TINFO_LIBRARY})
+      CHECK_C_SOURCE_COMPILES(
+       "#include <${CURSES_HDR}>
+         int main(void) {
+#ifdef ACS_ULCORNER
+         return ACS_ULCORNER;
+#endif
+         return 0; }"
+         TINFO_LINKSOK
+      )
+      IF(TINFO_LINKSOK)
+        LIST (APPEND EXTRA_LIBS ${CURSES_LIBRARY})
+        LIST (APPEND EXTRA_LIBS ${TINFO_LIBRARY})
+      ELSE()
+        MESSAGE(FATAL_ERROR "failed linking to ncurses library.")
+      ENDIF()
+    ENDIF()
+  ENDIF()
+ENDIF()
+
+SET(HAVE_PTHREAD)
+IF (NOT WIN32)
+ INCLUDE(FindThreads)
+ IF (CMAKE_USE_PTHREADS_INIT)
     SET (HAVE_PTHREAD 1)
-ENDIF (HAVE_PTHREAD_H)
+    IF (CMAKE_THREAD_LIBS_INIT)
+        LIST (APPEND EXTRA_LIBS ${CMAKE_THREAD_LIBS_INIT})
+    ENDIF()
+ ENDIF()
+ENDIF()
 
 CHECK_MULTI_FUNCTIONS_EXISTS(
     "getopt_long_only"
@@ -99,10 +155,6 @@
     vprintf
 )
 
-IF (HAVE_USLEEP)
-    SET (HAVE_USLEEP_PROTO 1)
-ENDIF (HAVE_USLEEP)
-
 CHECK_C_SOURCE_COMPILES(
  "#include <sys/types.h>
   #include <signal.h>
@@ -111,13 +163,10 @@
 )
 if(RETSIGTYPE_INT)
   set(RETSIGTYPE int)
-else(RETSIGTYPE_INT)
+else()
   set(RETSIGTYPE void)
-endif(RETSIGTYPE_INT)
+endif()
 MESSAGE(STATUS "Return type of signal handlers: ${RETSIGTYPE}")
-
-SET(CMAKE_REQUIRED_LIBRARIES "ncurses")
-CHECK_FUNCTION_EXISTS (resizeterm HAVE_NCURSES_RESIZETERM)
 
 SET(CMAKE_REQUIRED_INCLUDES ${MIKMOD_INCLUDE_DIR})
 SET(CMAKE_REQUIRED_LIBRARIES ${MIKMOD_LIBRARIES})
@@ -148,13 +197,11 @@
 ADD_DEFINITIONS("-DHAVE_CONFIG_H")
 SET (PACKAGE_DATA_DIR "${CMAKE_INSTALL_PREFIX}/share/mikmod")
 
-configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
-
-# So it can find the includes when building libavl.avl.h.
-INCLUDE_DIRECTORIES(BEFORE ${CMAKE_CURRENT_SOURCE_DIR})
+configure_file(${CMAKE_SOURCE_DIR}/config.h.cmake ${CMAKE_BINARY_DIR}/config.h)
 
 # So it can find config.h
-INCLUDE_DIRECTORIES(BEFORE ${CMAKE_CURRENT_BINARY_DIR})
+INCLUDE_DIRECTORIES(BEFORE ${CMAKE_SOURCE_DIR})
+INCLUDE_DIRECTORIES(BEFORE ${CMAKE_BINARY_DIR})
 
 install(
     FILES
@@ -164,6 +211,3 @@
 )
 
 add_subdirectory(src)
-add_subdirectory(dos)
-add_subdirectory(os2)
-add_subdirectory(win32)

=== debian/changelog ===
mikmod (3.2.6-1) unstable; urgency=medium

  * New upstream version.
  * lha is no longer available (in non-free), suggest jlha-utils instead
    (lhasa doesn't support the required 'p' command).
  * Add VCS information.
  * Drop 0004-Fix-hypens-in-the-manual-pages.patch, merged upstream.
  * convert_playlist is no longer provided.

 -- Stephen Kitt <skitt@debian.org>  Sun, 07 Sep 2014 14:34:58 +0200

=== debian/control ===
--- 
+++ 
@@ -5,12 +5,14 @@
 Build-Depends: debhelper (>= 9~), autotools-dev, libmikmod-dev (>= 3.3.4), libncurses5-dev
 Standards-Version: 3.9.5
 Homepage: http://mikmod.sf.net
+Vcs-Git: git://anonscm.debian.org/collab-maint/mikmod.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mikmod.git;a=summary
 
 Package: mikmod
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: oss-compat
-Suggests: bzip2, lha, unrar, unzip, zoo
+Suggests: bzip2, jlha-utils, unrar, unzip, zoo
 Description: Portable tracked music player
  Mikmod is a very portable tracked music player which supports a wide
  variety of module formats including compressed sample Impulse Tracker

## mikmod 3.2.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 2.8)
 LIST(APPEND CMAKE_MODULE_PATH "${mikmod_SOURCE_DIR}/cmake")
 
-SET(VERSION "3.2.6")
+SET(VERSION "3.2.7")
 
 STRING(REGEX MATCHALL "([0-9]+)" VERSION_DIGITS "${VERSION}")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -20,20 +20,20 @@
 
 IF (NOT HAVE_USLEEP)
     LIST (APPEND mikmod_SRCS "musleep.c")
-ENDIF (NOT HAVE_USLEEP)
+ENDIF()
 IF (NOT HAVE_FNMATCH)
     LIST (APPEND mikmod_SRCS "mfnmatch.c")
-ENDIF (NOT HAVE_FNMATCH)
+ENDIF()
 IF (NOT HAVE_GETOPT_LONG_ONLY)
     LIST (APPEND mikmod_SRCS "mgetopt.c")
     LIST (APPEND mikmod_SRCS "mgetopt1.c")
-ENDIF (NOT HAVE_GETOPT_LONG_ONLY)
+ENDIF()
 
 include_directories(${MIKMOD_INCLUDE_DIR})
 
 add_executable(mikmod ${mikmod_SRCS})
 
-target_link_libraries(mikmod "ncurses" "pthread" ${MIKMOD_LIBRARIES})
+target_link_libraries(mikmod ${MIKMOD_LIBRARIES} ${EXTRA_LIBS})
 
 install(TARGETS mikmod DESTINATION bin)

=== debian/changelog ===
mikmod (3.2.7-1build1) xenial; urgency=medium

  * No-change rebuild for ncurses6 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Feb 2016 09:43:09 +0000

mikmod (3.2.7-1) unstable; urgency=medium

  * New upstream version.
  * Standards-Version 3.9.6, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sun, 15 Nov 2015 22:37:06 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Stephen Kitt <skitt@debian.org>
 Build-Depends: debhelper (>= 9~), autotools-dev, libmikmod-dev (>= 3.3.4), libncurses5-dev
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://mikmod.sf.net
 Vcs-Git: git://anonscm.debian.org/collab-maint/mikmod.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mikmod.git;a=summary

=== debian/rules ===
#! /usr/bin/make -f

export DH_OPTIONS	+= -O-Bbuild

override_dh_auto_configure:
	dh_auto_configure -- --enable-color-interface

override_dh_auto_test: ;

%:
	dh $@ --with autotools_dev

## mikmod 3.2.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 2.8)
 LIST(APPEND CMAKE_MODULE_PATH "${mikmod_SOURCE_DIR}/cmake")
 
-SET(VERSION "3.2.7")
+SET(VERSION "3.2.8")
 
 STRING(REGEX MATCHALL "([0-9]+)" VERSION_DIGITS "${VERSION}")

=== debian/changelog ===
mikmod (3.2.8-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Wrap long lines in changelog entries: 2.14-3.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Name (from ./configure), Repository.

  [ Stephen Kitt ]
  * Stop suggesting zoo, it’s no longer available in the archives.
    Closes: #885502.
  * Set “Rules-Requires-Root: no”.
  * Switch to debhelper compatibility level 13.
  * Standards-Version 4.5.0, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 06 Jul 2020 18:07:29 +0200

mikmod (3.2.8-2) unstable; urgency=medium

  * Migrate to Salsa.
  * Fix a few spelling mistakes.
  * Switch to debhelper compatibility level 11.
  * Standards-Version 4.1.4, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Sun, 13 May 2018 18:22:37 +0200

mikmod (3.2.8-1) unstable; urgency=medium

  * New upstream release.
  * Switch to https: VCS URIs (see #810378).
  * Clean up debian/control using cme.
  * Standards-Version 3.9.8, no change required.
  * Switch to debhelper compatibility level 10.

 -- Stephen Kitt <skitt@debian.org>  Mon, 19 Jun 2017 22:10:27 +0200

=== debian/control ===
Source: mikmod
Maintainer: Stephen Kitt <skitt@debian.org>
Section: sound
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libmikmod-dev,
               libncurses5-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/mod-player-team/mikmod
Vcs-Git: https://salsa.debian.org/mod-player-team/mikmod.git
Homepage: http://mikmod.sf.net
Rules-Requires-Root: no

Package: mikmod
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: oss-compat
Suggests: bzip2,
          jlha-utils,
          unrar,
          unzip
Description: Portable tracked music player
 Mikmod is a very portable tracked music player which supports a wide
 variety of module formats including compressed sample Impulse Tracker
 modules. It also supports many archive formats, as well as on the fly
 decompression.

=== debian/rules ===
--- 
+++ 
@@ -8,4 +8,4 @@
 override_dh_auto_test: ;
 
 %:
-	dh $@ --with autotools_dev
+	dh $@

## mikmod 3.2.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,11 +2,11 @@
 # is installed, which you can do on your cmake command line, like:
 # cmake -DCMAKE_PREFIX_PATH=/path/to/libmikmod_dir ....
 
+CMAKE_MINIMUM_REQUIRED(VERSION 3.1...3.10)
 PROJECT(mikmod C)
-CMAKE_MINIMUM_REQUIRED(VERSION 2.8)
 LIST(APPEND CMAKE_MODULE_PATH "${mikmod_SOURCE_DIR}/cmake")
 
-SET(VERSION "3.2.8")
+SET(VERSION "3.2.9")
 
 STRING(REGEX MATCHALL "([0-9]+)" VERSION_DIGITS "${VERSION}")
 
@@ -18,8 +18,8 @@
 SET(CPACK_PACKAGE_NAME "mikmod")
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "MikMod - a module player")
 SET(CPACK_PACKAGE_VENDOR "Shlomi Fish")
-SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README")
-SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
+SET(CPACK_PACKAGE_DESCRIPTION_FILE "${PROJECT_SOURCE_DIR}/README")
+SET(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/COPYING")
 
 SET(CPACK_PACKAGE_INSTALL_DIRECTORY "${CPACK_PACKAGE_DESCRIPTION_SUMMARY} ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
 SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
@@ -49,11 +49,16 @@
     "/autom4te.cache/"
 )
 
+IF (POLICY CMP0075)
+    CMAKE_POLICY(SET CMP0075 NEW)
+ENDIF()
+
 INCLUDE(CPack)
 INCLUDE(CheckFunctionExists)
 INCLUDE(CheckSymbolExists)
 INCLUDE(CheckCCompilerFlag)
 INCLUDE(CheckCSourceCompiles)
+include(GNUInstallDirs)
 include(mik_macros)
 
 CHECK_MULTI_INCLUDE_FILES(
@@ -73,7 +78,7 @@
 
 find_path(MIKMOD_INCLUDE_DIR mikmod.h)
 find_library(MIKMOD_LIBRARIES mikmod)
-IF (MIKMOD_LIBRARIES STREQUAL "MIKMOD_LIBRARIES-NOTFOUND")
+IF (NOT MIKMOD_LIBRARIES)
     MESSAGE(FATAL_ERROR "libmikmod not found.")
 ELSE()
     MESSAGE(STATUS "Found MikMod: ${MIKMOD_LIBRARIES}")
@@ -110,7 +115,7 @@
     LIST (APPEND EXTRA_LIBS ${CURSES_LIBRARY})
   ELSE()
     find_library(TINFO_LIBRARY tinfo)
-    IF(TINFO_LIBRARY STREQUAL "TINFO_LIBRARY-NOTFOUND")
+    IF(NOT TINFO_LIBRARY)
       MESSAGE(FATAL_ERROR "libtinfo needed for ncurses, but not found.")
     ELSE()
       MESSAGE(STATUS "Found libtinfo: ${TINFO_LIBRARY}")
@@ -134,7 +139,6 @@
   ENDIF()
 ENDIF()
 
-SET(HAVE_PTHREAD)
 IF (NOT WIN32)
  INCLUDE(FindThreads)
  IF (CMAKE_USE_PTHREADS_INIT)
@@ -146,27 +150,12 @@
 ENDIF()
 
 CHECK_MULTI_FUNCTIONS_EXISTS(
-    "getopt_long_only"
-    mkstemp srandom snprintf vsnprintf strerror
+    getopt_long_only
+    mkstemp srandom snprintf vsnprintf
     usleep
     srandom
     fnmatch
-    memcmp
-    vprintf
-)
-
-CHECK_C_SOURCE_COMPILES(
- "#include <sys/types.h>
-  #include <signal.h>
-  int main(void) { return *(signal(0,0))(0) == 1; }"
-  RETSIGTYPE_INT
-)
-if(RETSIGTYPE_INT)
-  set(RETSIGTYPE int)
-else()
-  set(RETSIGTYPE void)
-endif()
-MESSAGE(STATUS "Return type of signal handlers: ${RETSIGTYPE}")
+)
 
 SET(CMAKE_REQUIRED_INCLUDES ${MIKMOD_INCLUDE_DIR})
 SET(CMAKE_REQUIRED_LIBRARIES ${MIKMOD_LIBRARIES})
@@ -180,7 +169,7 @@
 
 IF (CPU_ARCH)
     LIST(APPEND COMPILER_FLAGS_TO_CHECK "-march=${CPU_ARCH}")
-ENDIF(CPU_ARCH)
+ENDIF()
 
 SET (IDX 1)
 FOREACH (CFLAG_TO_CHECK ${COMPILER_FLAGS_TO_CHECK})
@@ -197,17 +186,17 @@
 ADD_DEFINITIONS("-DHAVE_CONFIG_H")
 SET (PACKAGE_DATA_DIR "${CMAKE_INSTALL_PREFIX}/share/mikmod")
 
-configure_file(${CMAKE_SOURCE_DIR}/config.h.cmake ${CMAKE_BINARY_DIR}/config.h)
+configure_file(${PROJECT_SOURCE_DIR}/config.h.cmake ${PROJECT_BINARY_DIR}/config.h)
 
 # So it can find config.h
-INCLUDE_DIRECTORIES(BEFORE ${CMAKE_SOURCE_DIR})
-INCLUDE_DIRECTORIES(BEFORE ${CMAKE_BINARY_DIR})
+INCLUDE_DIRECTORIES(BEFORE ${PROJECT_SOURCE_DIR})
+INCLUDE_DIRECTORIES(BEFORE ${PROJECT_BINARY_DIR})
 
 install(
     FILES
         mikmodrc
     DESTINATION
-        "share/mikmod"
+        ${CMAKE_INSTALL_DATADIR}/mikmod
 )
 
 add_subdirectory(src)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -18,15 +18,14 @@
    rcfile.c
 )
 
-IF (NOT HAVE_USLEEP)
+IF (NOT HAVE_USLEEP AND NOT WIN32 AND NOT OS2)
     LIST (APPEND mikmod_SRCS "musleep.c")
 ENDIF()
 IF (NOT HAVE_FNMATCH)
     LIST (APPEND mikmod_SRCS "mfnmatch.c")
 ENDIF()
 IF (NOT HAVE_GETOPT_LONG_ONLY)
-    LIST (APPEND mikmod_SRCS "mgetopt.c")
-    LIST (APPEND mikmod_SRCS "mgetopt1.c")
+    LIST (APPEND mikmod_SRCS "getopt_long.c")
 ENDIF()
 
 include_directories(${MIKMOD_INCLUDE_DIR})
@@ -35,5 +34,5 @@
 
 target_link_libraries(mikmod ${MIKMOD_LIBRARIES} ${EXTRA_LIBS})
 
-install(TARGETS mikmod DESTINATION bin)
-
+install(TARGETS mikmod DESTINATION ${CMAKE_INSTALL_BINDIR})
+install(FILES mikmod.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

=== debian/changelog ===
mikmod (3.2.9-1) unstable; urgency=medium

  * New upstream release.
  * Build-depend on libncurses-dev instead of libncurses5-dev.
  * Bump debian/watch to version 4.
  * Enable all hardening options.
  * Standards-Version 4.7.0, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 04 Jan 2025 17:37:02 +0100

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                libmikmod-dev,
-               libncurses5-dev
-Standards-Version: 4.5.0
+               libncurses-dev
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/mod-player-team/mikmod
 Vcs-Git: https://salsa.debian.org/mod-player-team/mikmod.git
 Homepage: http://mikmod.sf.net

=== debian/rules ===
#! /usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DH_OPTIONS += -O-Bbuild

override_dh_auto_configure:
	dh_auto_configure -- --enable-color-interface

override_dh_auto_test: ;

%:
	dh $@

=== debian/watch ===
version=4
http://sf.net/mikmod/mikmod-([^-]+)\.tar\.gz
